Program PlayWAV;                        { Compile/Target.../Protected :-) }
Uses CRT, WinAPI, SndBlast, WAVIO;

Const
  ErrorMsg : Array [1..4] of String[25] =
    ('File not found.', 'Unknown file format.',
     'Not enough memory.', 'File i/o error.');

Var
  P : Pointer;
  Size : LongInt;
  Channels : Word;
  Frequency,
  BytesPerSec : LongInt;
  BitsPerSample,
  Error : Word;

Label
  LFree;

Begin
  WriteLn ('PLAYWAV v1.0 by Alexei A. Frounze (c) 1998');
  If (ParamCount = 0) or (ParamStr(1) = '/?') then Begin
    WriteLn ('Usage: PLAYWAV.EXE <WAV-FILE> <');
    Exit
  End;
  If not CheckEnvironment then Begin
    WriteLn ('Could not find BLASTER variable in the environment.');
    Exit
  End;
  If not ResetSB then Begin
    WriteLn ('Could not reset Sound Blaster card.');
    Exit
  End;
  Write ('Loading WAV-file...');
  LoadWAVas8bit (ParamStr(1), P, Size, Channels, Frequency, BytesPerSec,
           BitsPerSample, Error);
  WriteLn (' done.');
  If Error <> 0 then Begin
    WriteLn (ErrorMsg[Error]);
    Exit
  End;
  Write   ('  Channels       : ', Channels);
  Case Channels of
    1 : WriteLn (' (mono)');
    2 : WriteLn (' (stereo)');
    Else WriteLn
  End;
  WriteLn ('  Samples per sec: ', Frequency);
  WriteLn ('  Bits per sample: ', BitsPerSample);
  If not Channels in [1,2] then Begin
    WriteLn ('Wrong number of channels, must be 1 or 2.');
    Goto LFree
  End;
  If not BitsPerSample in [8,16] then Begin
    WriteLn ('Couldn''t play a ', BitsPerSample, '-bit sound.');
    Goto LFree
  End;

  Set_DMA_End_Handler;
  SetStereoIO (Channels=2);
  Writeln ('Playing file...'#13#10'<SPACE> - pause, any other key - stop.');
  LongPlayback (P, Size, BytesPerSec);
  While Long_Back_On do Begin
    If KeyPressed then Begin
      Case Upcase(ReadKey) of
        #32 : Begin
                StopDMA;
                Write ('paused.');
                ReadKey;
                ContinueDMA;
                GotoXY (1, WhereY); ClrEOL
              End;
        Else  Begin
                WriteLn ('stopped.');
                StopDMA;
                SpeakerOff;
                While KeyPressed do ReadKey;
                Break
              End
      End
    End
  End;

  StopDMA;
  SpeakerOff;
  Restore_DMA_End_Handler;
LFree:
  GlobalFreePtr (P);
  FreeDOSBuf;
  WriteLn
End.
