Program RecWAV;                         { Compile/Target.../Protected :-) }
Uses CRT, DOS, WinAPI, SndBlast, WAVIO;

Const
  Name          : String = 'no file selected';
  Channels      : Word = 2;
  Frequency     : LongInt = 22050;
  InputSource   : Byte = Source_CD;
  Source        : Array [0..6] of String[15] = ('Microphone', '',
                  'Compact Disk', '', '2nd microphone', '', 'Line in');
  ChName        : Array [1..2] of String[6] = ('mono', 'stereo');
  ErrorMsg      : Array [1..4] of String[25] = ('File not found.', 'Unknown file format.',
                  'Not enough memory.', 'File i/o error.');
  P             : Pointer = Nil;
  Size          : LongInt = 0;
  MaxFree       : LongInt = 0;

Var
  BytesPerSec   : LongInt;
  BitsPerSample : Word;
  MasterVolume,
  InputVolume   : Byte;
  Ym            : Byte;
  C             : Char;

Function Size2Time (Size : LongInt; Channels : Word;
                                    Frequency : LongInt) : String;
Var
  S, SS : String;
  X : LongInt;
  H, M, Sc : Word;
Begin
{  Size := Size div (Channels * Frequency);}
  X := Channels; X := X * Frequency; Size := Size div X;
  H := Size div 3600; Size := Size mod 3600;
  M := Size div 60; Sc := Size mod 60;
  Str (H, SS); S := SS + ' Hours  ';
  Str (M, SS); S := S + SS + ' Min  ';
  Str (Sc, SS); S := S + SS + ' Sec';
  Size2Time := S
End;

Procedure SelectFile;
Begin
  Write ('Input file name: '); ReadLn (Name);
  If Name = '' then Exit;
  If P <> Nil then Begin
    GlobalFreePtr (P);
    P := Nil
  End
End;

Procedure SelectFrequency;
Label LRepeat;
Begin
  Write ('Input maximum frequency for record (4000...44100 Hz): ');
LRepeat:
  {$I-} ReadLn (Frequency); {$I+}
  If (IOResult <> 0) or
     (Frequency < 4000) or (Frequency > 44100) then Goto LRepeat
End;

Procedure SelectInput;
Var C : Char;
Begin
  WriteLn ('Select input source: ');
  WriteLn ('  M - Microphone'#13#10'  C - Compact Disk'#13#10'  L - Line in'#13#10);
  Repeat
    If KeyPressed then C := UpCase(ReadKey)
    Else C := #$FF;
    If C=#0 then ReadKey;
  Until C in ['M','C','L'];
  Case C of
    'M' : InputSource := Source_Mic1;
    'C' : InputSource := Source_CD;
    'L' : InputSource := Source_Line
  End;
  While KeyPressed do ReadKey
End;

Procedure RecordFile;
Var
  Error : Word;
Begin
  If Name = '' then Exit;
  If P <> Nil then Begin GlobalFreePtr (P); P := Nil End;
  Write ('Allocating memory...');
  P := GlobalAllocPtr (gmem_fixed, MaxFree);
  If P = Nil then Begin
    WriteLn ('It''s strange but unable allocate neded memory block.');
    ReadKey;
    Exit
  End;
  WriteLn (' done. Press any key to start...'); ReadKey;
  Writeln ('Recording file...'#13#10'<SPACE> - pause, any other key - stop.');
  BitsPerSample := 8;
  BytesPerSec := Channels; BytesPerSec := BytesPerSec * Frequency;
  SndBlast.SelectInput (InputSource);
  SetStereoIO (Channels=2);
  LongRecordback (P, MaxFree, BytesPerSec);
  While Long_Back_On do Begin
    Size := LongRecordLen;
    GotoXY (1, WhereY);
    Write (Size shr 10, ' KB - ', Size2Time(Size,Channels,Frequency));
    If KeyPressed then Begin
      Case Upcase(ReadKey) of
        #32 : Begin
                StopDMA;
                Write (' paused.');
                ReadKey;
                ContinueDMA;
                GotoXY (1, WhereY); ClrEOL
              End;
        Else  Begin
                Write (' stopped.');
                StopDMA;
                While KeyPressed do ReadKey;
                Break
              End
      End
    End
  End;
  WriteLn;
  Size := LongRecordLen;
  If Size > 0 then Begin
    Write ('Saving WAV-file...');
    SaveWAVas8bit (Name, P, Size, Channels, Frequency, Error);
    If Error <> 0 then Begin
      WriteLn (ErrorMsg[Error]);
      ReadKey;
      Exit
    End;
    WriteLn (' done.')
  End
End;

Procedure PlayFile;
Var
  Error : Word;
Begin
  If P = Nil then Begin
    If Name = '' then Exit;
    Write ('Loading WAV-file...');
    LoadWAVas8bit (Name, P, Size, Channels, Frequency, BytesPerSec,
                   BitsPerSample, Error);
    If Error <> 0 then Begin
      WriteLn (ErrorMsg[Error]);
      ReadKey;
      Exit
    End;
    WriteLn (' done.')
  End
  Else Begin
    If Size = 0 then Exit;
    BitsPerSample := 8;
    BytesPerSec := Channels; BytesPerSec := BytesPerSec * Frequency
  End;
  Write   ('  Channels       : ', Channels);
  Case Channels of
    1 : WriteLn (' (mono)');
    2 : WriteLn (' (stereo)');
    Else WriteLn
  End;
  WriteLn ('  Samples per sec: ', Frequency);
  WriteLn ('  Bits per sample: ', BitsPerSample);
  SetStereoIO (Channels=2);

  Writeln ('Playing file...'#13#10'<SPACE> - pause, any other key - stop.');
  LongPlayback (P, Size, BytesPerSec);
  While Long_Back_On do Begin
    If KeyPressed then Begin
      Case Upcase(ReadKey) of
        #32 : Begin
                StopDMA;
                Write ('paused.');
                ReadKey;
                ContinueDMA;
                GotoXY (1, WhereY); ClrEOL
              End;
        Else  Begin
                Write ('stopped.');
                StopDMA;
                SpeakerOff;
                While KeyPressed do ReadKey;
                Break
              End
      End
    End
  End;
  WriteLn
End;

Function GetMasterVolume : Byte;
Var V : Byte;
Begin
  V := GetMixerReg ($22);
  V := ((V and $F) + (V shr 4)) shr 1;
  GetMasterVolume := V
End;

Function GetCDVolume : Byte;
Var V : Byte;
Begin
  V := GetMixerReg ($28);
  V := ((V and $F) + (V shr 4)) shr 1;
  GetCDVolume := V
End;

Function GetLineVolume : Byte;
Var V : Byte;
Begin
  V := GetMixerReg ($2E);
  V := ((V and $F) + (V shr 4)) shr 1;
  GetLineVolume := V
End;

Function GetMicVolume : Byte;
Var V : Byte;
Begin
  V := GetMixerReg ($A);
  V := V and $F;
  GetMicVolume := V
End;

Procedure SetMasterVol;
Begin
  Write ('Enter master volume [0..15]: '); Read (MasterVolume);
  SetMasterVolume (MasterVolume, MasterVolume)
End;

Procedure SetInputVol;
Begin
  Write ('Enter input volume [0..15]: '); Read (InputVolume);
  Case InputSource of
    Source_Mic1 : SetMicVolume (InputVolume);
    Source_CD   : SetCDVolume (InputVolume, InputVolume);
    Source_Line : SetLineVolume (InputVolume, InputVolume)
  End
End;

Label LRefresh, LEnd;

Begin
  If SB_Base = 0 then Begin
    WriteLn ('The "BLASTER" variable is not found => Addr,IRQ,DMA are unknown!');
    Exit
  End;
  If not ResetSB then Begin
    WriteLn ('There is no access to Sound Blaster card!');
    Exit
  End;
  Set_DMA_End_Handler;
  MaxFree := MaxAvail;
  If MaxFree < 384*1024+32768 then Begin
    WriteLn (384*1024+32768, ' bytes needed at least.');
    WriteLn ('Only ', MaxFree, ' bytes free.');
    Goto LEnd;
  End;
  Dec (MaxFree, 32768);
LRefresh:
  MasterVolume := GetMasterVolume;
  Case InputSource of
    Source_Mic1 : InputVolume := GetMicVolume;
    Source_CD   : InputVolume := GetCDVolume;
    Source_Line : InputVolume := GetLineVolume;
  End;
  ClrScr;
  WriteLn ('Sound Blaster based WAV-RECORDER V1.0 by Alexei A. Frounze 1998 (c)'#13#10);
  WriteLn ('Current file               : ', Name);
  WriteLn ('Current recording frequency: ', Frequency, ' Hz');
  WriteLn ('Current input source       : ', Source[InputSource]);
  WriteLn ('Current channels count     : ', Channels,' (',ChName[Channels],')');
  WriteLn ('Avail. memory for recording: ', MaxFree shr 10, ' Kbytes');
  WriteLn ('Avail. recording time      : ', Size2Time(MaxFree, Channels, Frequency));
  WriteLn ('Master volume              : ', MasterVolume);
  WriteLn ('Input volume               : ', InputVolume);
  WriteLn; Ym := WhereY;
  WriteLn ('  S - Select file');
  WriteLn ('  F - Select maximum recording frequency');
  WriteLn ('  C - Toggle channels count');
  WriteLn ('  I - Select input source for record');
  WriteLn ('  R - Record file');
  WriteLn ('  P - Play file');
  WriteLn ('  M - Master volume control');
  WriteLn ('  V - Input volume control');
  WriteLn ('  X - Exit recorder'#13#10);
  Repeat
    If KeyPressed then C := UpCase(ReadKey)
    Else C := #$FF;
    If C in ['S','F','C','I','P','R','M','V'] then Begin
      Window (1, Ym, 80, Ym+8);
      ClrScr;
      Window (1, 1, 80, 25);
      GotoXY (1, Ym);
    End;
    Case C of
       #0 : ReadKey;
      'S' : SelectFile;
      'F' : SelectFrequency;
      'C' : Channels := 3 - Channels;
      'I' : SelectInput;
      'R' : RecordFile;
      'P' : PlayFile;
      'M' : SetMasterVol;
      'V' : SetInputVol;
    End;
    If C in ['S','F','C','I','P','R','M','V'] then Goto LRefresh;
  Until C = 'X';
  If P <> Nil then Begin GlobalFreePtr (P); P := Nil End;
  ClrScr;
LEnd:
  StopDMA;
  SpeakerOff;
  Restore_DMA_End_Handler;
  FreeDOSBuf
End.
